"use strict";
var cloneDeep = require('lodash.clonedeep');
function addFieldToSelectionSet(fieldName, queryPiece) {
    if (queryPiece == null || queryPiece.selections == null) {
        return queryPiece;
    }
    var typenameFieldAST = {
        kind: 'Field',
        alias: null,
        name: {
            kind: 'Name',
            value: fieldName,
        },
    };
    queryPiece.selections.map(function (child) {
        if (child.kind === 'Field' || child.kind === 'InlineFragment') {
            addTypenameToSelectionSet(child.selectionSet);
        }
    });
    queryPiece.selections.push(typenameFieldAST);
    return queryPiece;
}
exports.addFieldToSelectionSet = addFieldToSelectionSet;
function addTypenameToSelectionSet(queryPiece) {
    return addFieldToSelectionSet('__typename', queryPiece);
}
exports.addTypenameToSelectionSet = addTypenameToSelectionSet;
function addTypenameToQuery(queryDef) {
    var queryClone = cloneDeep(queryDef);
    this.addTypenameToSelectionSet(queryClone.selectionSet);
    return queryClone;
}
exports.addTypenameToQuery = addTypenameToQuery;
function applyTransformerToOperation(queryDef, queryTransformer) {
    var queryClone = cloneDeep(queryDef);
    queryTransformer(queryClone.selectionSet);
    return queryClone;
}
exports.applyTransformerToOperation = applyTransformerToOperation;
//# sourceMappingURL=queryTransform.js.map